freedombone-app-postactiv 26KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # postactiv application
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim media'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. POSTACTIV_DOMAIN_NAME=
  34. POSTACTIV_CODE=
  35. POSTACTIV_ONION_PORT=8100
  36. POSTACTIV_REPO="https://git.postactiv.com/postActiv/postActiv.git"
  37. POSTACTIV_COMMIT='3af66a0c66b36cb0e6111caef636eab383e423a1'
  38. POSTACTIV_ADMIN_PASSWORD=
  39. # script which causes old posts to expire
  40. postactiv_expire_script=/usr/bin/postactiv-expire
  41. postactiv_variables=(ONION_ONLY
  42. POSTACTIV_DOMAIN_NAME
  43. POSTACTIV_CODE
  44. DDNS_PROVIDER
  45. MY_USERNAME)
  46. function remove_user_postactiv {
  47. remove_username="$1"
  48. ${PROJECT_NAME}-pass -u $remove_username --rmapp postactiv
  49. function_check get_completion_param
  50. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  51. if [ -d /var/www/$POSTACTIV_DOMAIN_NAME ]; then
  52. cd /var/www/$POSTACTIV_DOMAIN_NAME/htdocs
  53. php scripts/deleteprofile.php -n $remove_username -y
  54. fi
  55. }
  56. function add_user_postactiv {
  57. new_username="$1"
  58. new_user_password="$2"
  59. ${PROJECT_NAME}-pass -u $new_username -a postactiv -p "$new_user_password"
  60. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  61. if [ -d /var/www/${POSTACTIV_DOMAIN_NAME}/htdocs ]; then
  62. cd /var/www/$POSTACTIV_DOMAIN_NAME/htdocs
  63. php scripts/registeruser.php -n $new_username -w "$new_user_password" -e "$new_username@$HOSTNAME"
  64. ${PROJECT_NAME}-addemail -u $new_username -e "noreply@$POSTACTIV_DOMAIN_NAME" -g postactiv --public no
  65. echo '0'
  66. else
  67. echo '1'
  68. fi
  69. }
  70. function install_interactive_postactiv {
  71. if [ ! $ONION_ONLY ]; then
  72. ONION_ONLY='no'
  73. fi
  74. if [[ $ONION_ONLY != "no" ]]; then
  75. POSTACTIV_DOMAIN_NAME='postactiv.local'
  76. else
  77. POSTACTIV_DETAILS_COMPLETE=
  78. while [ ! $POSTACTIV_DETAILS_COMPLETE ]
  79. do
  80. data=$(tempfile 2>/dev/null)
  81. trap "rm -f $data" 0 1 2 5 15
  82. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  83. dialog --backtitle $"Freedombone Configuration" \
  84. --title $"PostActiv Configuration" \
  85. --form $"\nPlease enter your postactiv details.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 14 65 2 \
  86. $"Domain:" 1 1 "$(grep 'POSTACTIV_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  87. $"Code:" 2 1 "$(grep 'POSTACTIV_CODE' temp.cfg | awk -F '=' '{print $2}')" 2 25 33 255 \
  88. 2> $data
  89. else
  90. dialog --backtitle $"Freedombone Configuration" \
  91. --title $"PostActiv Configuration" \
  92. --form $"\nPlease enter your postactiv details.\n\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 14 65 2 \
  93. $"Domain:" 1 1 "$(grep 'POSTACTIV_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  94. 2> $data
  95. fi
  96. sel=$?
  97. case $sel in
  98. 1) exit 1;;
  99. 255) exit 1;;
  100. esac
  101. POSTACTIV_DOMAIN_NAME=$(cat $data | sed -n 1p)
  102. img_url=$(cat $data | sed -n 3p)
  103. if [ $POSTACTIV_DOMAIN_NAME ]; then
  104. if [[ $POSTACTIV_DOMAIN_NAME == "$HUBZILLA_DOMAIN_NAME" ]]; then
  105. POSTACTIV_DOMAIN_NAME=""
  106. fi
  107. TEST_DOMAIN_NAME=$POSTACTIV_DOMAIN_NAME
  108. validate_domain_name
  109. if [[ $TEST_DOMAIN_NAME != $POSTACTIV_DOMAIN_NAME ]]; then
  110. POSTACTIV_DOMAIN_NAME=
  111. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  112. else
  113. if [[ $DDNS_PROVIDER == "default@freedns.afraid.org" ]]; then
  114. POSTACTIV_CODE=$(cat $data | sed -n 4p)
  115. validate_freedns_code "$POSTACTIV_CODE"
  116. if [ ! $VALID_CODE ]; then
  117. POSTACTIV_DOMAIN_NAME=
  118. fi
  119. fi
  120. fi
  121. fi
  122. if [ $POSTACTIV_DOMAIN_NAME ]; then
  123. POSTACTIV_DETAILS_COMPLETE="yes"
  124. fi
  125. done
  126. # save the results in the config file
  127. write_config_param "POSTACTIV_CODE" "$POSTACTIV_CODE"
  128. fi
  129. write_config_param "POSTACTIV_DOMAIN_NAME" "$POSTACTIV_DOMAIN_NAME"
  130. APP_INSTALLED=1
  131. }
  132. function change_password_postactiv {
  133. curr_username="$1"
  134. new_user_password="$2"
  135. read_config_param ${POSTACTIV_DOMAIN_NAME}
  136. cd /var/www/${POSTACTIV_DOMAIN_NAME}/htdocs/scripts
  137. php setpassword.php "$curr_username" "$new_user_password"
  138. ${PROJECT_NAME}-pass -u "$curr_username" -a postactiv -p "$new_user_password"
  139. }
  140. function postactiv_create_database {
  141. if [ -f $IMAGE_PASSWORD_FILE ]; then
  142. POSTACTIV_ADMIN_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  143. else
  144. if [ ! $POSTACTIV_ADMIN_PASSWORD ]; then
  145. POSTACTIV_ADMIN_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  146. fi
  147. fi
  148. if [ ! $POSTACTIV_ADMIN_PASSWORD ]; then
  149. return
  150. fi
  151. function_check create_database
  152. create_database postactiv "$POSTACTIV_ADMIN_PASSWORD" $MY_USERNAME
  153. }
  154. function postactiv_running_script {
  155. # check that the daemon is running
  156. echo '#!/bin/bash' > /etc/cron.hourly/postactiv-daemons
  157. echo 'daemon_lines=$(ps aux | grep "scripts/queuedaemon.php" | grep "/var/www")' >> /etc/cron.hourly/postactiv-daemons
  158. echo 'if [[ $daemon_lines != *"/var/www/"* ]]; then' >> /etc/cron.hourly/postactiv-daemons
  159. echo " ADMIN_USER=\$(cat $COMPLETION_FILE | grep 'Admin user' | awk -F ':' '{print \$2}')" >> /etc/cron.hourly/postactiv-daemons
  160. echo ' MY_EMAIL_ADDRESS=$ADMIN_USER@$HOSTNAME' >> /etc/cron.hourly/postactiv-daemons
  161. echo ' echo "Restarting postactiv daemons" | mail -s "postactiv daemons not found" $MY_EMAIL_ADDRESS' >> /etc/cron.hourly/postactiv-daemons
  162. echo " cd /var/www/${POSTACTIV_DOMAIN_NAME}/htdocs" >> /etc/cron.hourly/postactiv-daemons
  163. echo ' scripts/startdaemons.sh' >> /etc/cron.hourly/postactiv-daemons
  164. echo 'fi' >> /etc/cron.hourly/postactiv-daemons
  165. chmod +x /etc/cron.hourly/postactiv-daemons
  166. }
  167. function reconfigure_postactiv {
  168. echo -n ''
  169. }
  170. function upgrade_postactiv {
  171. if grep -q "postactiv domain" $COMPLETION_FILE; then
  172. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  173. fi
  174. # update to the next commit
  175. function_check set_repo_commit
  176. set_repo_commit /var/www/$POSTACTIV_DOMAIN_NAME/htdocs "postactiv commit" "$POSTACTIV_COMMIT" $POSTACTIV_REPO
  177. #function_check postactiv_running_script
  178. #postactiv_running_script
  179. }
  180. function backup_local_postactiv {
  181. POSTACTIV_DOMAIN_NAME='postactiv'
  182. if grep -q "postactiv domain" $COMPLETION_FILE; then
  183. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  184. fi
  185. source_directory=/var/www/${POSTACTIV_DOMAIN_NAME}/htdocs
  186. if [ -d $source_directory ]; then
  187. dest_directory=postactiv
  188. function_check suspend_site
  189. suspend_site ${POSTACTIV_DOMAIN_NAME}
  190. function_check backup_directory_to_usb
  191. backup_directory_to_usb $source_directory $dest_directory
  192. function_check backup_database_to_usb
  193. backup_database_to_usb postactiv
  194. function_check restart_site
  195. restart_site
  196. fi
  197. }
  198. function restore_local_postactiv {
  199. if ! grep -q "postactiv domain" $COMPLETION_FILE; then
  200. return
  201. fi
  202. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  203. if [ $POSTACTIV_DOMAIN_NAME ]; then
  204. temp_restore_dir=/root/temppostactiv
  205. postactiv_dir=/var/www/${POSTACTIV_DOMAIN_NAME}/htdocs
  206. # stop the daemons
  207. cd $postactiv_dir
  208. scripts/stopdaemons.sh
  209. function_check postactiv_create_database
  210. postactiv_create_database
  211. restore_database postactiv ${POSTACTIV_DOMAIN_NAME}
  212. if [ -d $temp_restore_dir ]; then
  213. rm -rf $temp_restore_dir
  214. fi
  215. # start the daemons
  216. cd $postactiv_dir
  217. scripts/startdaemons.sh
  218. fi
  219. }
  220. function backup_remote_postactiv {
  221. if grep -q "postactiv domain" $COMPLETION_FILE; then
  222. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  223. temp_backup_dir=/var/www/${POSTACTIV_DOMAIN_NAME}/htdocs
  224. if [ -d $temp_backup_dir ]; then
  225. function_check suspend_site
  226. suspend_site ${POSTACTIV_DOMAIN_NAME}
  227. function_check backup_database_to_friend
  228. backup_database_to_friend postactiv
  229. function_check backup_directory_to_friend
  230. backup_directory_to_friend $temp_backup_dir postactiv
  231. function_check restart_site
  232. restart_site
  233. else
  234. echo $"postactiv domain specified but not found in ${temp_backup_dir}"
  235. fi
  236. fi
  237. }
  238. function restore_remote_postactiv {
  239. if grep -q "postactiv domain" $COMPLETION_FILE; then
  240. POSTACTIV_DOMAIN_NAME=$(get_completion_param "postactiv domain")
  241. # stop the daemons
  242. cd /var/www/${POSTACTIV_DOMAIN_NAME}/htdocs
  243. ./scripts/stopdaemons.sh
  244. function_check postactiv_create_database
  245. postactiv_create_database
  246. function_check restore_database_from_friend
  247. restore_database_from_friend postactiv ${POSTACTIV_DOMAIN_NAME}
  248. if [ -d /root/temppostactiv ]; then
  249. rm -rf /root/temppostactiv
  250. fi
  251. # start the daemons
  252. cd /var/www/${POSTACTIV_DOMAIN_NAME}/htdocs
  253. ./scripts/startdaemons.sh
  254. fi
  255. }
  256. function remove_postactiv {
  257. if [ ${#POSTACTIV_DOMAIN_NAME} -eq 0 ]; then
  258. return
  259. fi
  260. read_config_param "POSTACTIV_DOMAIN_NAME"
  261. read_config_param "MY_USERNAME"
  262. echo "Removing $POSTACTIV_DOMAIN_NAME"
  263. nginx_dissite $POSTACTIV_DOMAIN_NAME
  264. remove_certs $POSTACTIV_DOMAIN_NAME
  265. if [ -f /var/www/$POSTACTIV_DOMAIN_NAME/htdocs/scripts/stopdaemons.sh ]; then
  266. cd /var/www/$POSTACTIV_DOMAIN_NAME/htdocs/scripts
  267. ./scripts/stopdaemons.sh
  268. fi
  269. if [ -d /var/www/$POSTACTIV_DOMAIN_NAME ]; then
  270. rm -rf /var/www/$POSTACTIV_DOMAIN_NAME
  271. fi
  272. if [ -f /etc/nginx/sites-available/$POSTACTIV_DOMAIN_NAME ]; then
  273. rm /etc/nginx/sites-available/$POSTACTIV_DOMAIN_NAME
  274. fi
  275. function_check drop_database
  276. drop_database postactiv
  277. function_check remove_onion_service
  278. remove_onion_service postactiv ${POSTACTIV_ONION_PORT}
  279. if grep -q "postactiv" /etc/crontab; then
  280. sed -i "/postactiv/d" /etc/crontab
  281. fi
  282. remove_app postactiv
  283. remove_completion_param install_postactiv
  284. sed -i '/postactiv/d' $COMPLETION_FILE
  285. if [ -f /etc/cron.hourly/postactiv-daemons ]; then
  286. rm /etc/cron.hourly/postactiv-daemons
  287. fi
  288. remove_backup_database_local postactiv
  289. function_check remove_ddns_domain
  290. remove_ddns_domain $POSTACTIV_DOMAIN_NAME
  291. }
  292. function install_postactiv_main {
  293. if [ ! $POSTACTIV_DOMAIN_NAME ]; then
  294. echo $'No domain name was given for postactiv'
  295. exit 7359
  296. fi
  297. if [[ $(app_is_installed postactiv_main) == "1" ]]; then
  298. return
  299. fi
  300. #function_check postactiv_running_script
  301. #postactiv_running_script
  302. function_check install_mariadb
  303. install_mariadb
  304. function_check get_mariadb_password
  305. get_mariadb_password
  306. function_check repair_databases_script
  307. repair_databases_script
  308. apt-get -yq install php-gettext php5-curl php5-gd php5-mysql git curl php-xml-parser
  309. apt-get -yq install php5-memcached php5-intl
  310. if [ ! -d /var/www/$POSTACTIV_DOMAIN_NAME ]; then
  311. mkdir /var/www/$POSTACTIV_DOMAIN_NAME
  312. fi
  313. if [ ! -d /var/www/$POSTACTIV_DOMAIN_NAME/htdocs ]; then
  314. function_check git_clone
  315. git_clone $POSTACTIV_REPO /var/www/$POSTACTIV_DOMAIN_NAME/htdocs
  316. if [ ! -d /var/www/$POSTACTIV_DOMAIN_NAME/htdocs ]; then
  317. echo $'Unable to clone postactiv repo'
  318. exit 87525
  319. fi
  320. fi
  321. cd /var/www/$POSTACTIV_DOMAIN_NAME/htdocs
  322. git checkout $POSTACTIV_COMMIT -b $POSTACTIV_COMMIT
  323. set_completion_param "postactiv commit" "$POSTACTIV_COMMIT"
  324. chmod a+w /var/www/$POSTACTIV_DOMAIN_NAME/htdocs
  325. chown www-data:www-data /var/www/$POSTACTIV_DOMAIN_NAME/htdocs
  326. chmod +x /var/www/$POSTACTIV_DOMAIN_NAME/htdocs/scripts/maildaemon.php
  327. function_check postactiv_create_database
  328. postactiv_create_database
  329. if [ ! -f "/etc/aliases" ]; then
  330. touch /etc/aliases
  331. fi
  332. if ! grep -q "www-data: root" /etc/aliases; then
  333. echo 'www-data: root' >> /etc/aliases
  334. fi
  335. if ! grep -q "/var/www/$POSTACTIV_DOMAIN_NAME/htdocs/scripts/maildaemon.php" /etc/aliases; then
  336. echo "*: /var/www/$POSTACTIV_DOMAIN_NAME/htdocs/scripts/maildaemon.php" >> /etc/aliases
  337. fi
  338. function_check add_ddns_domain
  339. add_ddns_domain $POSTACTIV_DOMAIN_NAME
  340. postactiv_nginx_site=/etc/nginx/sites-available/$POSTACTIV_DOMAIN_NAME
  341. if [[ $ONION_ONLY == "no" ]]; then
  342. function_check nginx_http_redirect
  343. nginx_http_redirect $POSTACTIV_DOMAIN_NAME
  344. echo 'server {' >> $postactiv_nginx_site
  345. echo ' listen 443 ssl;' >> $postactiv_nginx_site
  346. echo ' listen [::]:443 ssl;' >> $postactiv_nginx_site
  347. echo " server_name $POSTACTIV_DOMAIN_NAME;" >> $postactiv_nginx_site
  348. echo '' >> $postactiv_nginx_site
  349. echo ' # Security' >> $postactiv_nginx_site
  350. function_check nginx_ssl
  351. nginx_ssl $POSTACTIV_DOMAIN_NAME
  352. function_check nginx_disable_sniffing
  353. nginx_disable_sniffing $POSTACTIV_DOMAIN_NAME
  354. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $postactiv_nginx_site
  355. echo '' >> $postactiv_nginx_site
  356. echo ' # Logs' >> $postactiv_nginx_site
  357. echo ' access_log /dev/null;' >> $postactiv_nginx_site
  358. echo ' error_log /dev/null;' >> $postactiv_nginx_site
  359. echo '' >> $postactiv_nginx_site
  360. echo ' # Root' >> $postactiv_nginx_site
  361. echo " root /var/www/$POSTACTIV_DOMAIN_NAME/htdocs;" >> $postactiv_nginx_site
  362. echo '' >> $postactiv_nginx_site
  363. echo ' # Index' >> $postactiv_nginx_site
  364. echo ' index index.php;' >> $postactiv_nginx_site
  365. echo '' >> $postactiv_nginx_site
  366. echo ' # PHP' >> $postactiv_nginx_site
  367. echo ' location ~ \.php {' >> $postactiv_nginx_site
  368. echo ' include snippets/fastcgi-php.conf;' >> $postactiv_nginx_site
  369. echo ' fastcgi_pass unix:/var/run/php5-fpm.sock;' >> $postactiv_nginx_site
  370. echo ' }' >> $postactiv_nginx_site
  371. echo '' >> $postactiv_nginx_site
  372. echo ' # Location' >> $postactiv_nginx_site
  373. echo ' location / {' >> $postactiv_nginx_site
  374. function_check nginx_limits
  375. nginx_limits $POSTACTIV_DOMAIN_NAME '15m'
  376. echo ' try_files $uri $uri/ @postactiv;' >> $postactiv_nginx_site
  377. echo ' }' >> $postactiv_nginx_site
  378. echo '' >> $postactiv_nginx_site
  379. echo ' # Fancy URLs' >> $postactiv_nginx_site
  380. echo ' location @postactiv {' >> $postactiv_nginx_site
  381. echo ' rewrite ^(.*)$ /index.php?p=$1 last;' >> $postactiv_nginx_site
  382. echo ' }' >> $postactiv_nginx_site
  383. echo '' >> $postactiv_nginx_site
  384. echo ' # Restrict access that is unnecessary anyway' >> $postactiv_nginx_site
  385. echo ' location ~ /\.(ht|git) {' >> $postactiv_nginx_site
  386. echo ' deny all;' >> $postactiv_nginx_site
  387. echo ' }' >> $postactiv_nginx_site
  388. echo '' >> $postactiv_nginx_site
  389. nginx_keybase ${POSTACTIV_DOMAIN_NAME}
  390. echo '}' >> $postactiv_nginx_site
  391. else
  392. echo -n '' > $postactiv_nginx_site
  393. fi
  394. echo 'server {' >> $postactiv_nginx_site
  395. echo " listen 127.0.0.1:$POSTACTIV_ONION_PORT default_server;" >> $postactiv_nginx_site
  396. echo " server_name $POSTACTIV_DOMAIN_NAME;" >> $postactiv_nginx_site
  397. echo '' >> $postactiv_nginx_site
  398. function_check nginx_disable_sniffing
  399. nginx_disable_sniffing $POSTACTIV_DOMAIN_NAME
  400. echo '' >> $postactiv_nginx_site
  401. echo ' # Logs' >> $postactiv_nginx_site
  402. echo ' access_log /dev/null;' >> $postactiv_nginx_site
  403. echo ' error_log /dev/null;' >> $postactiv_nginx_site
  404. echo '' >> $postactiv_nginx_site
  405. echo ' # Root' >> $postactiv_nginx_site
  406. echo " root /var/www/$POSTACTIV_DOMAIN_NAME/htdocs;" >> $postactiv_nginx_site
  407. echo '' >> $postactiv_nginx_site
  408. echo ' # Index' >> $postactiv_nginx_site
  409. echo ' index index.php;' >> $postactiv_nginx_site
  410. echo '' >> $postactiv_nginx_site
  411. echo ' # PHP' >> $postactiv_nginx_site
  412. echo ' location ~ \.php {' >> $postactiv_nginx_site
  413. echo ' include snippets/fastcgi-php.conf;' >> $postactiv_nginx_site
  414. echo ' fastcgi_pass unix:/var/run/php5-fpm.sock;' >> $postactiv_nginx_site
  415. echo ' }' >> $postactiv_nginx_site
  416. echo '' >> $postactiv_nginx_site
  417. echo ' # Location' >> $postactiv_nginx_site
  418. echo ' location / {' >> $postactiv_nginx_site
  419. function_check nginx_limits
  420. nginx_limits $POSTACTIV_DOMAIN_NAME '15m'
  421. echo ' try_files $uri $uri/ @postactiv;' >> $postactiv_nginx_site
  422. echo ' }' >> $postactiv_nginx_site
  423. echo '' >> $postactiv_nginx_site
  424. echo ' # Fancy URLs' >> $postactiv_nginx_site
  425. echo ' location @postactiv {' >> $postactiv_nginx_site
  426. echo ' rewrite ^(.*)$ /index.php?p=$1 last;' >> $postactiv_nginx_site
  427. echo ' }' >> $postactiv_nginx_site
  428. echo '' >> $postactiv_nginx_site
  429. echo ' # Restrict access that is unnecessary anyway' >> $postactiv_nginx_site
  430. echo ' location ~ /\.(ht|git) {' >> $postactiv_nginx_site
  431. echo ' deny all;' >> $postactiv_nginx_site
  432. echo ' }' >> $postactiv_nginx_site
  433. echo '' >> $postactiv_nginx_site
  434. nginx_keybase ${POSTACTIV_DOMAIN_NAME}
  435. echo '}' >> $postactiv_nginx_site
  436. function_check configure_php
  437. configure_php
  438. function_check create_site_certificate
  439. create_site_certificate $POSTACTIV_DOMAIN_NAME 'yes'
  440. # Ensure that the database gets backed up locally, if remote
  441. # backups are not being used
  442. function_check backup_databases_script_header
  443. backup_databases_script_header
  444. function_check backup_database_local
  445. backup_database_local postactiv
  446. function_check nginx_ensite
  447. nginx_ensite $POSTACTIV_DOMAIN_NAME
  448. # NOTE: For the typical case always enable SSL and only
  449. # disable it if in onion only mode. This is due to complexities
  450. # with the way URLs are generated by postactiv
  451. postactiv_ssl='always'
  452. if [[ $ONION_ONLY != 'no' ]]; then
  453. postactiv_ssl='never'
  454. fi
  455. POSTACTIV_ONION_HOSTNAME=$(add_onion_service postactiv 80 ${POSTACTIV_ONION_PORT})
  456. POSTACTIV_SERVER=${POSTACTIV_DOMAIN_NAME}
  457. if [[ $ONION_ONLY != 'no' ]]; then
  458. POSTACTIV_SERVER=${POSTACTIV_ONION_HOSTNAME}
  459. fi
  460. # Create the configuration
  461. postactiv_installer=/var/www/${POSTACTIV_DOMAIN_NAME}/htdocs/scripts/install_cli.php
  462. if [ ! -f $postactiv_installer ]; then
  463. rm -rf /var/www/$POSTACTIV_DOMAIN_NAME
  464. echo $'No postactiv commandline installer found'
  465. exit 53026
  466. fi
  467. ${postactiv_installer} --server "${POSTACTIV_SERVER}" \
  468. --host="localhost" --database="postactiv" \
  469. --dbtype=mysql --username="root" -v \
  470. --password="$MARIADB_PASSWORD" \
  471. --sitename=$"postactiv" --fancy='yes' \
  472. --admin-nick="$MY_USERNAME" \
  473. --admin-pass="$POSTACTIV_ADMIN_PASSWORD" \
  474. --site-profile="community" \
  475. --ssl=${postactiv_ssl}
  476. # There can be a lot of warnings here so the return value check is disabled
  477. #if [ ! "$?" = "0" ]; then
  478. # # failed to install
  479. # echo $'Could not install postactiv'
  480. # exit 72357
  481. #fi
  482. # check postactiv has a config file
  483. postactiv_config_file=/var/www/$POSTACTIV_DOMAIN_NAME/htdocs/config.php
  484. if [ ! -f $postactiv_config_file ]; then
  485. drop_database postactiv
  486. rm -rf /var/www/$POSTACTIV_DOMAIN_NAME
  487. echo $'Postactiv config.php not found'
  488. exit 87586
  489. fi
  490. # Some useful settings
  491. if ! grep -q "Recommended postactiv settings" $postactiv_config_file; then
  492. echo "" >> $postactiv_config_file
  493. echo "// Recommended postactiv settings" >> $postactiv_config_file
  494. echo "\$config['thumbnail']['maxsize'] = 3000;" >> $postactiv_config_file
  495. echo "\$config['profile']['delete'] = true;" >> $postactiv_config_file
  496. echo "\$config['profile']['changenick'] = true;" >> $postactiv_config_file
  497. echo "\$config['public']['localonly'] = false;" >> $postactiv_config_file
  498. echo "addPlugin('StoreRemoteMedia');" >> $postactiv_config_file
  499. echo "\$config['queue']['enabled'] = true;" >> $postactiv_config_file
  500. echo "\$config['queue']['daemon'] = true;" >> $postactiv_config_file
  501. echo "\$config['ostatus']['hub_retries'] = 3;" >> $postactiv_config_file
  502. fi
  503. # This improves performance
  504. sed -i "s|//\$config\['db'\]\['schemacheck'\].*|\$config\['db'\]\['schemacheck'\] = 'script';|g" $postactiv_config_file
  505. # remove the install script
  506. if [ -f /var/www/$POSTACTIV_DOMAIN_NAME/htdocs/install.php ]; then
  507. rm /var/www/$POSTACTIV_DOMAIN_NAME/htdocs/install.php
  508. fi
  509. systemctl restart php5-fpm
  510. systemctl restart nginx
  511. ${PROJECT_NAME}-addemail -u $MY_USERNAME -e "noreply@$POSTACTIV_DOMAIN_NAME" -g postactiv --public no
  512. ${PROJECT_NAME}-pass -u $MY_USERNAME -a postactiv -p "$POSTACTIV_ADMIN_PASSWORD"
  513. set_completion_param "postactiv domain" "$POSTACTIV_DOMAIN_NAME"
  514. install_completed postactiv_main
  515. }
  516. function expire_postactiv_posts {
  517. # To prevent the database size from growing endlessly this script expires posts
  518. # after a number of months
  519. if [ ! -d /var/www/$POSTACTIV_DOMAIN_NAME/htdocs ]; then
  520. return
  521. fi
  522. echo '<?php' > $postactiv_expire_script
  523. echo '' >> $postactiv_expire_script
  524. echo '// postactiv post expiry script, based on StatExpire by Tony Baldwin' >> $postactiv_expire_script
  525. echo '// https://github.com/tonybaldwin/statexpire' >> $postactiv_expire_script
  526. echo '' >> $postactiv_expire_script
  527. echo '$oldate=date(("Y-m-d"), strtotime("-3 months"));' >> $postactiv_expire_script
  528. echo '$username="root";' >> $postactiv_expire_script
  529. echo "\$password=shell_exec('${PROJECT_NAME}-pass -u root -a mariadb');" >> $postactiv_expire_script
  530. echo '$database="postactiv";' >> $postactiv_expire_script
  531. echo '' >> $postactiv_expire_script
  532. echo 'if (!$link = mysql_connect("localhost", $username, $password)) {' >> $postactiv_expire_script
  533. echo ' echo "Could not connect to mariadb";' >> $postactiv_expire_script
  534. echo ' exit;' >> $postactiv_expire_script
  535. echo '}' >> $postactiv_expire_script
  536. echo '' >> $postactiv_expire_script
  537. echo 'if (!mysql_select_db($database, $link)) {' >> $postactiv_expire_script
  538. echo ' echo "Could not select postactiv database";' >> $postactiv_expire_script
  539. echo ' exit;' >> $postactiv_expire_script
  540. echo '}' >> $postactiv_expire_script
  541. echo '' >> $postactiv_expire_script
  542. echo "\$notice_query=\"DELETE FROM notice WHERE created <= '\$oldate 01:01:01'\";" >> $postactiv_expire_script
  543. echo "\$conversation_query=\"DELETE FROM conversation WHERE created <= '$oldate 01:01:01'\";" >> $postactiv_expire_script
  544. echo "\$reply_query=\"DELETE FROM reply WHERE modified <= '\$oldate 01:01:01'\";" >> $postactiv_expire_script
  545. echo '' >> $postactiv_expire_script
  546. echo 'mysql_query($notice_query);' >> $postactiv_expire_script
  547. echo '$rowaff1=mysql_affected_rows();' >> $postactiv_expire_script
  548. echo 'mysql_query($conversation_query);' >> $postactiv_expire_script
  549. echo '$rowaff2=mysql_affected_rows();' >> $postactiv_expire_script
  550. echo 'mysql_query($reply_query);' >> $postactiv_expire_script
  551. echo '$rowaff3=mysql_affected_rows();' >> $postactiv_expire_script
  552. echo 'mysql_close();' >> $postactiv_expire_script
  553. echo '' >> $postactiv_expire_script
  554. echo 'echo "Expire postactiv posts: $rowaff1 notices, $rowaff2 conversations, and $rowaff3 replies deleted from database.\n";' >> $postactiv_expire_script
  555. chmod +x $postactiv_expire_script
  556. # Add a cron job
  557. if ! grep -q "$postactiv_expire_script" /etc/crontab; then
  558. echo "10 3 5 * * root /usr/bin/timeout 500 /usr/bin/php $postactiv_expire_script" >> /etc/crontab
  559. fi
  560. # remove old expire script
  561. if [ -f /etc/cron.weekly/clear-postactiv-database ]; then
  562. rm /etc/cron.weekly/clear-postactiv-database
  563. fi
  564. }
  565. function install_postactiv {
  566. if [ ! $ONION_ONLY ]; then
  567. ONION_ONLY='no'
  568. fi
  569. install_postactiv_main
  570. expire_postactiv_posts
  571. # unleash the daemons!
  572. /etc/cron.hourly/postactiv-daemons
  573. APP_INSTALLED=1
  574. }
  575. # NOTE: deliberately there is no "exit 0"